// language options

const strings_language = { 
	"de": {
		"diary": "Tagebuch",
		"settings": "Einstellungen",
		"statistics": "Statistik",
		"lastentry": "Letzter Eintrag",
		"mindindex": "Mind-Index",
		"adventuretoday": "Was hast Du heute erlebt?",
		"pleasefillin": "Was fehlt?",
		"pleaseadd": "Bitte ausfüllen",
		"continue": "Weiter >",
		"today": "heute",
		"yesterday": "gestern",
		"skip": "Überspringen",
		"adventure": "Erlebnis eintragen",
		"test": "Gedächtnis testen",
		"doyouremember": "Weißt Du noch, ...?",
		"on": "am",
		"clickme": "Klicke, um die Aufgabe zu sehen",
		"testfailed": "Das war leider nicht richtig",
		"testpartlyfailed": "Ja, fast richtig!",
		"testsuccessful": "Perfekt! Alles richtig!",
		"restart": "neues Erlebnis",
		"days": "Tage",
		"numberofadventures": "Anzahl Erlebnisse",
		"numberoftests": "Anzahl Tests",
		"remembered": "davon erinnert",
		"timespan": "Zeitraum",
		"sorrynotest": "Leider ist derzeit kein Test möglich",
		"sorrynostats": "Leider gibt es noch zu wenige Daten für eine Statistik",
		"darkmode": "Dunkelmodus",
		"editadventure": "Bearbeite Erlebnis",
		"of1": "vom",
		"of2": "von",
		"summary": "Übersicht",
		"delete": "Erlebnis löschen",
		"deletereally": "Erlebnis wirklich löschen?",
		"export": "Alle Erlebnisse exportieren",
		"import": "Erlebnisse importieren",
		"downloadhere": "Hier klicken, um Exportdatei herunterladen",
		"importsuccessful": "Import war erfolgreich.",
		"importfailed": "Import ist gescheitert.",
		"importfromfile": "Datei auswählen",
		"importfromclipboard": "aus dem Zwischenspeicher",
		"exportsuccessful": "Export war erolgreich.",
		"exportfailed": "Export ist gescheitert. Hast Du die Erlaubnis 'Speicher' aktiviert?",
		"infoheader": "<b>Habsgleich</b> - Minitagebuch und Gedächtnistest",
		"authorcc": "<b>Autor</b> codecivil Dr. Marco Kühnel ICT Services",
		"version": "<b>Version</b> 1.8",
		"license": "<b>Lizenz</b> GPLv3",
		"sourcecode": "<b>Quellcode</b> https://gitlab.com/codecivil/habsgleich",
		"documentation": "<b>Dokumentation</b> https://habsgleich.docs.codecivil.de",
		"howtouse": "<b>Mind-Index</b> Der Mind-Index sagt in etwa aus, wie lange Einträge in Tagen zurück liegen dürfen, damit Du Dich gut daran erinnern kannst. Der Mind-Index wird bei täglichen Einträgen etwa 14 Tage benötigen, bis er sich auf dem richtigen Niveau eingependelt hat. Ab dann sind größere Änderungen aussagekräftig.",
		"info": "Über diese App",
		"password": "Passwort",
		"oldpassword": "altes Passwort",
		"newpassword": "neues Passwort",
		"confirmnewpassword": "bitte wiederholen",
		"passwordsubmit": "Passwort ändern",
		"changepasswordsubmit": "Passwort ändern",
		"nopasswordsubmit": "ohne Passwort benutzen",
		"loginsubmit": "freischalten",
		"setpasswordsubmit": "Passwort setzen",
		"text_setpassword": "<p>Wir empfehlen, ein Passwort zur Verschlüsselung Deiner Erlebnisse zu setzen.</p><p><b>Bitte bewahre das Passwort sicher auf. Wenn Du es verlierst, musst Du die App neu installieren und verlierst alle bisherigen Erlebnisse.</b></p>",
		"text_nopassword": "",
		"text_login": "Bitte gib Dein Passwort ein.",
		"text_changepassword": "Gib zunächst das bisherige Passwort, dann das neue zweimal ein.",
		"progress": "Verschlüssele Erlebnisse",
		"passwd": "Passwort verwalten",
		"decryptfailed": "<anders verschlüsselt>",
		"changelog": "<b>Changelog</b>",
		"logout": "Abmelden",
		"remindme": "tägliche Erinnerung",
		"reminder": "HabsGleich - Erinnerung",
		"reminder_text": "Hey, willst Du mal wieder ein Erlebnis aufschreiben?",
		"yeswhynot": "Ja, gute Idee...",
		"notnow": "Nein, jetzt nicht.",
		"imprint": "Impressum",
		"dataprotection": "Datenschutz",
		"donationspalpay": "<b>Spenden via Palpay</b><br>https://paypal.me/codecivil",
		"donationsliberapay": "<b>Regelmäßig spenden via Liberapay</b><br>https://liberapay.com/codecivil",
		"alltime": "von Anfang an",
		"lastyear": "letztes Jahr",
		"last6months": "letzte 6 Monate",
		"last3months": "letzte 3 Monate",
		"lastmonth": "letzter Monat",
		"confirmdelete": "Löschen bestätigen",
		"yes": "Ja",
		"no": "Nein",
		"onlineversion": "<b>Online-Version</b><br>https://habsgleich.codecivil.de",
		"demo": "Demo-Version! Wenn Du Deine Browserdaten löschst, sind alle Eintragungen und Einstellungen entfernt. Du kannst jedoch mittels der Export- und Importfunktionen Deine Erlebnisse sichern und dann auch wiederherstellen.",
		"yourmindindex": "Dein Mind-Index"
	},
	"en": {
		"diary": "Diary",
		"settings": "Settings",
		"statistics": "Statistics",
		"lastentry": "last entry",
		"mindindex": "mind index",
		"adventuretoday": "How was your day?",
		"pleasefillin": "fill the gap",
		"pleaseadd": "please fill in",
		"continue": "continue >",
		"today": "today",
		"yesterday": "yesterday",
		"skip": "skip",
		"adventure": "Add an adventure",
		"test": "Test your mind",
		"doyouremember": "Do you remember?",
		"on": "on",
		"clickme": "Click to see the task",
		"testfailed": "Sorry, that's wrong",
		"testpartlyfailed": "Yeah, almost correct!",
		"testsuccessful": "Well done! Well done, indeed!",
		"restart": "new adventure",
		"days": "days",
		"numberofadventures": "adventures",
		"numberoftests": "tests",
		"remembered": "remembered",
		"timespan": "time span",
		"sorrynotest": "Sorry, currently there's no test avaiable",
		"sorrynostats": "Sorry, not yet enough data for statistics",
		"darkmode": "dark mode",
		"editadventure": "edit adventure",
		"of1": "of",
		"of2": "of",
		"summary": "Summary",
		"delete": "delete adventure",
		"deletereally": "Really delete this adventure?",
		"export": "export all adventures",
		"import": "import adventures",
		"downloadhere": "Click to download export file",
		"importsuccessful": "Import successful.",
		"importfailed": "Import failed.",
		"importfromfile": "select file",
		"importfromclipboard": "from clipboard",
		"exportsuccessful": "Export successful.",
		"exportfailed": "Export failed. Did you set the storage permission?",
		"infoheader": "<b>Habsgleich</b> - mini diary and mind test",
		"authorcc": "<b>Author</b> codecivil Dr. Marco Kühnel ICT Services",
		"version": "<b>Version</b> 1.8",
		"license": "<b>License</b> GPLv3",
		"sourcecode": "<b>Source code</b> https://gitlab.com/codecivil/habsgleich",
		"documentation": "<b>Documentation</b> https://habsgleich.docs.codecivil.de",
		"howtouse": "<b>mind index</b> The mind index indicates how long you can remember events well. It takes about two weeks before the mind index should stabilize on a meaningful level. Then, also smaller changes have some significance.",
		"info": "About this app",
		"password": "password",
		"oldpassword": "old password",
		"newpassword": "new password",
		"confirmnewpassword": "please repeat",
		"passwordsubmit": "change password",
		"changepasswordsubmit": "change password",
		"nopasswordsubmit": "use without password",
		"loginsubmit": "decrypt",
		"setpasswordsubmit": "set password",
		"text_setpassword": "<p>We recommend setting a password. This will encrypt your adventures.</p><p><b>Please store your password safely. If you loose it, you will loose access to all saved adventures.</b></p>",
		"text_nopassword": "",
		"text_login": "Please type your password",
		"text_changepassword": "First, give your current password, then type your new password twice.",
		"progress": "crypt adventures",
		"passwd": "edit password",
		"decryptfailed": "<unknown encryption>",
		"changelog": "<b>Changelog</b>",
		"logout": "Logout",
		"remindme": "daily reminder",
		"reminder": "HabsGleich - Reminder",
		"reminder_text": "Hey, do you want to note another adventure?",
		"yeswhynot": "Yes, why not...",
		"notnow": "No, not now.",
		"imprint": "Imprint",
		"dataprotection": "Data Protection Policy",
		"donationspalpay": "<b>Donations via Palpay</b> https://paypal.me/codecivil",
		"donationsliberapay": "<b>Regular donations via Liberapay</b> https://liberapay.com/codecivil",
		"alltime": "from start",
		"lastyear": "last year",
		"last6months": "last 6 months",
		"last3months": "last 3 months",
		"lastmonth": "last month",
		"confirmdelete": "Confirm delete",
		"yes": "Yes",
		"no": "No",
		"onlineversion": "<b>Online version</b><br>https://habsgleich.codecivil.de",
		"demo": "Demo version! If you clear your browser data, all adventures and settings are lost. You can export and then reimport your adventures and settings, however.",
		"yourmindindex": "Your mind index"
	},
}

// find preferred language and set strings accordingly

var strings = strings_language.en; // English is default

let _langhit = false;
navigator.languages.forEach(lang => {
	Object.keys(strings_language).forEach(_key => {
		if ( ! _langhit && lang.indexOf(_key) > -1 ) { strings = strings_language[_key]; _langhit = true; }
	});
});

const blacklist = [
"ich",
"du",
"er",
"sie",
"es",
"wir",
"ihr",
"sie",
"sein",
"bin",
"bist",
"ist",
"sind",
"seid",
"habe",
"hast",
"hat",
"haben",
"habt",
"war",
"warst",
"waren",
"wart",
"hatte",
"hattest",
"hatten",
"hattet",
"ein",
"eine",
"eines",
"einer",
"der",
"die",
"das",
"den",
"dem",
"des",
"dessen",
"wer",
"wie",
"was",
"wessen",
"wen",
"wem",
"warum",
"deshalb",
"weshalb",
"wieso",
"da",
"dort",
"hier",
"nun",
"jetzt",
"heute",
"zu"];
